FUNCTION spiral::Init, r=r, dist=dist, height=height, width=width, DENSITY=density, $
                     _EXTRA=e
    IF (self->IDLgrModel::Init(_EXTRA=e) NE 1) THEN RETURN, 0
    self.r=0.2
    self.dist=0.2
    self.height=1.0
    self.width=0.0
    self.density = 10
    IF (N_ELEMENTS(r) EQ 1) THEN self.r = r
    IF (N_ELEMENTS(dist) EQ 1) THEN self.dist = dist
    IF (N_ELEMENTS(height) EQ 1) THEN self.height = height
    IF (N_ELEMENTS(width) EQ 1) THEN self.width = width
    IF (N_ELEMENTS(density) EQ 1) THEN self.density = density
    self.oPoly = OBJ_NEW('IDLgrPolygon', SHADING=1, _EXTRA=e)
    self->Add,self.oPoly
    self->BuildPoly
    RETURN, 1
END

;----------------------------------------------------------------------------
PRO spiral::Cleanup
    OBJ_DESTROY, self.oPoly
    self->IDLgrModel::Cleanup
END

;----------------------------------------------------------------------------
PRO spiral::SetProperty, r=r, dist=dist, height=height, width=width, DENSITY=density, _EXTRA=e
    self->IDLgrModel::SetProperty, _EXTRA=e
    self.oPoly->SetProperty, _EXTRA=e
    IF (N_ELEMENTS(r) EQ 1) THEN self.r = r
    IF (N_ELEMENTS(dist) EQ 1) THEN self.dist = dist
    IF (N_ELEMENTS(height) EQ 1) THEN self.height = height
    IF (N_ELEMENTS(width) EQ 1) THEN self.width = width
    IF (N_ELEMENTS(density) EQ 1) THEN self.density = density
    self->BuildPoly
END

;----------------------------------------------------------------------------
PRO spiral::GetProperty, r=r, dist=dist, height=height, width=width, DENSITY=density,$
                         POBJ=pobj, _EXTRA=e
    self->IDLgrModel::GetProperty, _EXTRA=e
    self.oPoly->GetProperty, _EXTRA=e
    r = self.r
    dist = self.dist
    height=self.height
    width=self.width
    density = self.density
    pobj = self.oPoly
END

;----------------------------------------------------------------------------
PRO spiral::BuildPoly


    ;---------------data-----------------
    konst=2*!pi*self.height/self.dist
    nt=fix(self.density*self.height*7)
    t=konst*findgen(nt)/(nt-1)
    nfi=self.density
    fi=2*!pi*findgen(nfi)/nfi
    n=nt*nfi
    x=findgen(n)
    y=findgen(n)
    z=findgen(n)

    for i=0,nt-1 do begin
        i2=nt-1-i
        for j=0,nfi-1 do begin
            x(j+i*nfi)=self.width*cos(fi(j))*cos(t(i2))-self.width*sin(fi(j))*sin(t(i2))*self.dist/(2*!pi*sqrt((self.r)^2+(self.dist/(2*!pi))^2))+self.r*cos(t(i2))
            y(j+i*nfi)=self.width*cos(fi(j))*sin(t(i2))+self.width*sin(fi(j))*cos(t(i2))*self.dist/(2*!pi*sqrt((self.r)^2+(self.dist/(2*!pi))^2))+self.r*sin(t(i2))
            z(j+i*nfi)=-self.width*sin(fi(j))*self.r/sqrt(((self.r)^2+(self.dist/(2*!pi))^2))+t(i2)*self.dist/(2*!pi)
        endfor
    endfor
    data=transpose([[x],[y],[z]])

    ;for i=0,nt-1 do begin   rozepsane po krocich
    ;    i2=nt-1-i
    ;    B=[self.r*cos(omega*t(i2)),self.r*sin(omega*t(i2)),vz*t(i2)]
    ;    vx=-omega*B(1) ;ziskame jako derivaci x, y a z
    ;    vy=omega*B(0)
    ;    vz=vz
    ;    v=sqrt(vx^2+vy^2+vz^2)
    ;    costheta=vz/v
    ;    sintheta=sqrt((vx^2+vy^2)/(v^2))
    ;    cosksi=vy/(v*sintheta)
    ;    sinksi=vx/(v*sintheta)
    ;    M=[[cosksi,sinksi*costheta,sinksi*sintheta],[-sinksi,cosksi*costheta,cosksi*sintheta],[0.0,-sintheta,costheta]]
    ;    for j=0,nfi-1 do begin
    ;        point=[self.width*cos(fi(j)),self.width*sin(fi(j)),0.0]
    ;        point=(M##point)+B
    ;        x(j+i*nfi)=point(0)
    ;        y(j+i*nfi)=point(1)
    ;        z(j+i*nfi)=point(2)
    ;    endfor
    ;endfor
    ;data=transpose([[x],[y],[z]])


    ;--------------polygons----------------------------
    dim=nfi*(nt-1) ;nfi*(ndistance-2)
    polygon1=intarr(5,dim)
    polygon1(0,*)=4
    polygon1(1,*)=indgen(dim)
    polygon1(2,*)=indgen(dim)+1
    polygon1(3,*)=indgen(dim)+nfi+1
    polygon1(4,*)=indgen(dim)+nfi
    for i=0,nt-2 do begin
        polygon1(2,(i+1)*nfi-1)=polygon1(1,i*nfi)
        polygon1(3,(i+1)*nfi-1)=polygon1(4,i*nfi)
    endfor
    polygon1=reform(polygon1,5*dim)
    self.oPoly->SetProperty, DATA=data , POLYGONS=polygon1


END

;-----------------------------------------------------------
PRO spiral_define
    struct = { spiral, $
               INHERITS IDLgrModel, $
               r:0.2,$
               dist:0.2,$
               height: 1.0,$
               width:0.0,$
               density: 10, $
               oPoly: OBJ_NEW() $
             }
END







